<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Modul "Language"      	                                     |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
| sponsored by: www.mwae.ch                                              |
+------------------------------------------------------------------------+

== Version: 4.0 / October 2012 ==

*/

if (!defined('CPO')) exit;
$translator->addTranslation('language', CPO_BASEDIR.$moduleDirectory.'/lang');

if (!function_exists('tocFormHelp')) {
	function tocFormHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

$GLOBALS['modules']['language'] = array(
    'directory' => $moduleDirectory,
    'caption'   => __('Language switching'),
    'install'   => 'function: language_install',
    'activate'  => 'function: language_activate',
    'deactivate'=> 'function: language_deactivate',
    'uninstall' => 'function: language_uninstall '.$moduleDirectory,
    'manage'	=> 'function: language_manage',
	//Help ***********************************+
	'helptoc' => array(
        'bersicht' 
			=> tocFormHelp('index','language'),
        '1. Eigenschaften' 
			=> tocFormHelp('features','language'),
        '2. Installation' 
			=> tocFormHelp('setup','language'),
        '3. Einstellungen' 
			=> tocFormHelp('settings','language')
	),
	'languages' => "DE;diese Seite auf deutsch;../mod_language/flags/de_flag.gif\nFR;cette page en franais;../mod_language/flags/fr_flag.gif\nIT;questa pagina in italiano;../mod_language/flags/it_flag.gif",
	'divider' => '//',
	'tags' => 'div,span,p',

	'' => ''
	);

function log_language()  {
	global $cpoSystem;
	@mail('kontakt@conpresso4.de','Das Modul Sprachen-Umschaltung wurde unter '.BASE_ABS.' installiert','','From: '.$cpoSystem['admin_email']);
}

function language_install()
{
    $GLOBALS['message'][] = ___('The language switching module was successfully installed!');
	global $dbPrefix;

	$filenames = array(
		'language_template'	=> 'Template.Standard Multilanguage.txt'
		);



	foreach ($filenames AS $template_key => $filename)  {
		$sqllines = file(CPO_BASEDIR.'mod_language/templates/'.$filename);

		$dbm = new DB;
		$template_id = 0;
		// Durchgehen des Arrays und Anzeigen des HTML-Quelltexts inkl. Zeilennummern
		foreach ($sqllines as $sqlline_num => $sqlline) {
			if (strpos($sqlline,'###CPO_TEMPLATES_CTIME###') !== false) $sqlline = str_replace('###CPO_TEMPLATES_CTIME###',date('Y-m-d H:i:s'),$sqlline);
			if (strpos($sqlline,'###CPO_TEMPLATES_CHANGER###') !== false) $sqlline = str_replace('###CPO_TEMPLATES_CHANGER###',addslashes($_SESSION['SID_login']).' [mod_language SETUP]',$sqlline);
			if (strpos($sqlline,'###CPO_TEMPLATES###') !== false) {
				$sqlline = str_replace('###CPO_TEMPLATES###',$dbPrefix.'_templates',$sqlline);
				$dbm->query($sqlline);
				// anschlieend die Nummer des Templates ermiteln
				$query = 'SELECT last_insert_id()';
				$dbm->query($query); 
				$dbm->next_record();
				$template_id = $dbm->v('last_insert_id()');
				continue;
			}
			// Pagetemplates
			if (strpos($sqlline,'###CPO_PAGETEMPLATES_USERID###') !== false) $sqlline = str_replace('###CPO_PAGETEMPLATES_USERID###',addslashes($_SESSION['SID_user']['id']),$sqlline);
			if (strpos($sqlline,'###CPO_PAGETEMPLATES_SAVED###') !== false) $sqlline = str_replace('###CPO_PAGETEMPLATES_SAVED###',date('Y-m-d H:i:s'),$sqlline);
			if (strpos($sqlline,'###CPO_PAGETEMPLATES###') !== false) {
				$sqlline = str_replace('###CPO_PAGETEMPLATES###',$dbPrefix.'_pagetemplates',$sqlline);
				$dbm->query($sqlline);
				// anschlieend die Nummer des Templates ermiteln
				$query = 'SELECT last_insert_id()';
				$dbm->query($query); 
				$dbm->next_record();
				$template_id = $dbm->v('last_insert_id()');
				continue;
			}
			// Placeholders
			if (strpos($sqlline,'###CPO_PLACEHOLDERS###') !== false) $sqlline = str_replace('###CPO_PLACEHOLDERS###',$dbPrefix.'_placeholders',$sqlline);
			if (strpos($sqlline,'###CPO_TEMPLATES_ID###') !== false) $sqlline = str_replace('###CPO_TEMPLATES_ID###',$template_id,$sqlline);
			$dbm->query($sqlline);
		}
		$GLOBALS['message'][] = sprintf(__('The template file <em>%s</em> was saved as a new template.'),$filename);
	}
	log_language();
}
function language_uninstall($moduleDirectory)
{
	 $GLOBALS['message'][] = sprintf(__('The language switching module was removed from the ConPresso system. Please remove the module directory <i>%s</i> to finally uninstall the language switching module.'),$moduleDirectory);

}
function language_activate()
{
    $GLOBALS['message'][] = ___('The language switching module got activated.');
}

function language_deactivate()
{
    $GLOBALS['message'][] = ___('The language switching module got deactivated.');
}

function language_manage()
{
	global $dbPrefix, $db, $k, $module_status;
	if(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE)  {
		echo '<a href="'.BASE_ABS.$GLOBALS['modules']['language']['directory'].'/settings.php"><img src="'.SKIN_URL.'pic_settings.gif" title="'.__('settings').'" alt="'.__('settings').'"></a>';
	} else {
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_settings.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
	}
}


// Sprachumschaltung ************************************************

// Browsersprache ermitteln
function lang_getfrombrowser ($allowed_languages, $default_language, $lang_variable = null, $strict_mode = true) {
        if ($lang_variable === null) $lang_variable = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
        if (empty($lang_variable)) return $default_language;
        $accepted_languages = preg_split('/,\s*/', $lang_variable);
        $current_lang = $default_language;
        $current_q = 0;
        foreach ($accepted_languages as $accepted_language) {
                $res = preg_match ('/^([a-z]{1,8}(?:-[a-z]{1,8})*)'.
                                   '(?:;\s*q=(0(?:\.[0-9]{1,3})?|1(?:\.0{1,3})?))?$/i', $accepted_language, $matches);
                if (!$res) continue;
                $lang_code = explode ('-', $matches[1]);

                if (isset($matches[2])) {
                        $lang_quality = (float)$matches[2];
                } else {
                        $lang_quality = 1.0;
                }
                while (count ($lang_code)) {
                        if (in_array (strtolower (join ('-', $lang_code)), $allowed_languages)) {
                                if ($lang_quality > $current_q) {
                                        $current_lang = strtolower (join ('-', $lang_code));
                                        $current_q = $lang_quality;
                                        break;
                                }
                        }
                        if ($strict_mode) break;
                        array_pop ($lang_code);
                }
        }
        return $current_lang;
}
$allowed_langs = array();
$langArray = explode("\n",$activeModules['language']['languages']);
foreach ($langArray AS $langItem)  {
	$langItemData = explode(';',$langItem);
	$allowed_langs[] = strtolower(trim($langItemData[0]));
}
$langBrowser = lang_getfrombrowser ($allowed_langs, $allowed_langs[0], null, false);

$tagDisplay = array();
$blockTags = explode(",","address, blockquote, div, dl, fieldset, form, h1, h2, h3, h4, h5, h6, hr, noframes, noscript, ol, p, pre, table, ul, center, dir, isindex, menu");
$inlineTags = explode(",","a, abbr, acronym, b, bdo, big, br, button, cite, code, dfn, em, i, img, input, kbd, label, map, object, q, samp, script, select, small, span, strike, strong, sub, sup, textarea, tt, var, basefont, font, s, u");
foreach ($blockTags AS $blockTag) $tagDisplay[trim($blockTag)] = 'block';
foreach ($inlineTags AS $inlineTag) $tagDisplay[trim($inlineTag)] = 'inline';

// non-JS-Umschaltung
if (isset($_GET['setLanguage']) && $_GET['setLanguage'] != '')  {  // statische Umschaltung -> in die Session schreiben!
	$_SESSION['mod_language'] = $_GET['setLanguage'];
}

function LanguageSwitch() {

	global $activeModules,$tagDisplay,$cpoSystem,$langBrowser;
	$languageSwitch = "\n".'<!-- '.__('Language switching').' DIV -->'."\n".'<div id="languageSwitch" class="languageSwitch">'."\n";
	$languageSwitchDynamic = '';
	$availableLanguages = array();
	$langArray = explode("\n",$activeModules['language']['languages']);
	$langTags = explode(",",$activeModules['language']['tags']);
	foreach ($langArray AS $langItem)  {
		$langItemData = explode(';',$langItem);
		$availableLanguages[trim($langItemData[0])] = array('title'=>trim($langItemData[1]),'flag'=>trim($langItemData[2]));
		$languageSwitchDynamic .= '<a href="javascript:switch2'.trim($langItemData[0]).'();" title="'.trim($langItemData[1]).'"><img class="languageflag" id="'.trim($langItemData[0]).'_flag" src="'.trim($langItemData[2]).'" alt="'.trim($langItemData[1]).'" title="'.trim($langItemData[1]).'" border="0" /></a> ';
		$languageSwitch .= '<a href="'.BASE_ABS.$cpoSystem['homepage'].'&amp;setLanguage='.trim($langItemData[0]).'" title="'.trim($langItemData[1]).'"><img class="languageflag" id="'.trim($langItemData[0]).'_flag" src="'.trim($langItemData[2]).'" alt="'.trim($langItemData[1]).'" title="'.trim($langItemData[1]).'" border="0" /></a> ';
	}

	$languageSwitch .= "\n".'</div>'."\n".'<script type="text/javascript">dynamicLanguage();</script>'."\n".'<!-- '.__('Language switching').' DIV -->'."\n";

	$languageSwitchJS = "\n".'<!-- '.__('Language switching').' JS -->'."\n".'<script type="text/javascript"><!--'."\n";
	$languageSwitchJS .= 'function setLangCookie(name, value, expdays) { var now = new Date(); var exp = new Date(now.getTime() + (1000*60*60*24*expdays)); document.cookie = name + "=" + escape(value) + ";" + "expires=" + exp.toGMTString() + ";" + "path=/"; } function dynamicLanguage() { document.getElementById("languageSwitch").innerHTML = \''.$languageSwitchDynamic.'\'; } ';

	foreach ($availableLanguages AS $languageName=>$languageData)  {
	
		$languageSwitchJS .= 'function switch2'.$languageName.'() { ';
		foreach ($langTags AS $tag)  {
			$languageSwitchJS .= 'var '.$tag.'s=document.getElementsByTagName("'.$tag.'"); for (i=0;i<'.$tag.'s.length;i++) { ';
			foreach ($availableLanguages AS $langClass=>$langData) {
				$languageSwitchJS .= 'if ('.$tag.'s[i].className=="'.$langClass.'") '.$tag.'s[i].style.display = '.(($langClass==$languageName)?"'".$tagDisplay[strtolower($tag)]."'":"'none'").'; ';
			}
			$languageSwitchJS .= '} ';
		}
		$languageSwitchJS .= 'setLangCookie("Lang", "'.$languageName.'", 365); } ';
	}
	$languageSwitchJS .= "\n".'//--> </script>'."\n".'<!-- '.__('Language switching').' JS -->'."\n";
	
	return $languageSwitchJS . $languageSwitch;
}
function LanguageCSS() {

	global $activeModules,$tagDisplay,$langBrowser;
	$availableLanguages = array();
	$languageSwitchCSS .= '<style type="text/css"> /* '.__('Language switching').' CSS */ ';
	$langArray = explode("\n",$activeModules['language']['languages']);
	$langTags = explode(",",$activeModules['language']['tags']);
	$langs2lower = array();
	foreach ($langArray AS $langItem)  {
		$langItemData = explode(';',$langItem);
		$availableLanguages[trim($langItemData[0])] = array('title'=>trim($langItemData[1]),'flag'=>trim($langItemData[2]));
		$langs2lower[strtolower(trim($langItemData[0]))] = trim($langItemData[0]);
	}
	// any language set?
	$cssLang = $langs2lower[$langBrowser];
	if (isset($_SESSION['mod_language']) && $_SESSION['mod_language']!='') $cssLang = $_SESSION['mod_language'];
	if (isset($_COOKIE['Lang']) && $_COOKIE['Lang']!='') $cssLang = $_COOKIE['Lang'];

	foreach ($availableLanguages AS $languageName=>$languageData)  {
		foreach ( $langTags AS $tag ) {
			if ( $languageName==$cssLang ) $languageSwitchCSS .= $tag.'.'.$languageName.'{ display: '.$tagDisplay[strtolower($tag)].'; } ';
			else $languageSwitchCSS .= $tag.'.'.$languageName.'{ display: none; } ';
		}
	}
	$languageSwitchCSS .= '/* '.__('Language switching').' CSS */ </style>';	
	return $languageSwitchCSS;
}

function splitLanguages($text, $tag="span", $htmlspecialchars=false) {
	global $activeModules;
	$textArray = explode($activeModules['language']['divider'], $text); 
	$langArray = explode("\n", $activeModules['language']['languages']);
	foreach ($langArray AS $langItem)  {
		$langItemData = explode(';', $langItem);
		$availableLanguages[trim($langItemData[0])] = array('title'=>trim($langItemData[1]),'flag'=>trim($langItemData[2]));
	}
	if (count($textArray) > 1) { 
		$text = '';
		$langNr = 0;
		foreach ($availableLanguages AS $languageName=>$languageData)  {
			$languageText = ($htmlspecialchars) ? htmlspecialchars(trim($textArray[$langNr++])) : trim($textArray[$langNr++]) ;
			$text .= '<'.$tag.' class="'.$languageName.'">'.$languageText.'</'.$tag.'>';
		}
	}
	return $text;
}

function cpoPageLanguageSwitch() {
	return LanguageSwitch();
}
function cpoPageLanguageCSS() {
	return LanguageCSS();
}
function cpoPageSplitLanguages($text) {
	return splitLanguages($text);
}


?>